#ifndef _LED_STREAM_H
#define _LED_STREAM_H

#include <propeller.h>
#include <stdint.h>

#define LVDS_COLS   1024
#define LVDS_ROWS   600

#define LVDS_TEXT_COLS  (LVDS_COLS/8)
#define LVDS_TEXT_ROWS  (LVDS_ROWS/16) // there will be a half tile gap at the bottom

typedef struct lvds_t {
    uint32_t p;
    uint32_t dbg1;
    uint32_t dbg2;

    uint8_t fb[LVDS_ROWS*LVDS_COLS/8]; // 1 bit pixels, left to right, top to bottom

    // functions
    int32_t (*start)(struct lvds_t *l, uint8_t pin);
    void (*_char)(struct lvds_t *l, int32_t x, int32_t y, char c);
    void (*str)(struct lvds_t *l, int32_t x, int32_t y, const char *c);

} lvds_t;

lvds_t *LVDS(lvds_t *l);

#endif
