#include <propeller.h>
#include "sys/p2es_clock.h" // must be inluded in top level for defining _SETFREQ and _CLOCKFREQ based on defined clock frequency in makefile

#include <stdio.h>
#include <stdint.h>

#include "lvds.h"

#define PIN 8

void _init() {
    clkset(_SETFREQ, _CLOCKFREQ);
    _setbaud(115200);
}

void main() {
    _init();

    lvds_t l = *LVDS(&l);

    printf("Running at %u MHz\n", CLKFREQ/1000000);

    for (int i = 0; i < LVDS_ROWS*LVDS_COLS/8; i++) {
        l.fb[i] = 0; // clear the frame buffer
    }

    int r = l.start(&l, PIN);

    int32_t i = 0;
    while(1) {
        l.str(&l, i, i++, "Hello World!");
        if (i == LVDS_TEXT_ROWS) i = 0;
        waitcnt(CLKFREQ/2 + CNT);
    }
}
